Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 54)
@@ -30,127 +30,203 @@
 #include <pj/pool.h>
 #include <pj/assert.h>
-
-#define MGR_IDLE_CHECK_INTERVAL	30
-#define MGR_HASH_TABLE_SIZE	PJSIP_MAX_DIALOG_COUNT
-#define BACKLOG			5
-#define DEFAULT_SO_SNDBUF	(8 * 1024 * 1024)
-#define DEFAULT_SO_RCVBUF	(8 * 1024 * 1024)
-
-#define LOG_TRANSPORT_MGR	"trmgr"	
-#define THIS_FILE		"sip_transport"
-
-static void destroy_transport( pjsip_transport_mgr *mgr, pjsip_transport_t *tr );
-
-
-/**
- * New TCP socket for accept.
- */
-typedef struct incoming_socket_rec
-{
-    pj_sock_t		sock;
-    pj_sockaddr_in	remote;
-    pj_sockaddr_in	local;
-    int			addrlen;
-} incoming_socket_rec;
-
-/**
- * SIP Transport.
- */
-struct pjsip_transport_t
-{
-    /** Standard list members, for chaining the transport in the 
-     *  listener list. 
-     */
-    PJ_DECL_LIST_MEMBER(struct pjsip_transport_t);
-
-    /** Transport's pool. */
-    pj_pool_t		*pool;
-
-    /** Mutex */
-    pj_mutex_t		*tr_mutex;
-
-    /** Transport name for logging purpose */
-    char		 obj_name[PJ_MAX_OBJ_NAME];
-
-    /** Socket handle */
-    pj_sock_t		 sock;
-
-    /** Transport type. */
-    pjsip_transport_type_e type;
-
-    /** Flags to keep various states (see pjsip_transport_flags_e). */
-    pj_uint32_t		 flag;
-
-    /** I/O Queue key */
-    pj_ioqueue_key_t	*key;
-
-    /** Accept key. */
-    pj_ioqueue_op_key_t	 accept_op;
-
-    /** Receive data buffer */
-    pjsip_rx_data	*rdata;
-
-    /** Pointer to transport manager */
-    pjsip_transport_mgr *mgr;
-
-    /** Reference counter, to prevent this transport from being closed while
-     *  it's being used. 
-     */
-    pj_atomic_t		 *ref_cnt;
-
-    /** Local address. */
-    pj_sockaddr_in	 local_addr;
-
-    /** Address name (what to put in Via address field). */
-    pj_sockaddr_in	 addr_name;
-
-    /** Remote address (can be zero for UDP and for listeners). UDP listener
-     *  bound to local loopback interface (127.0.0.1) has remote address set
-     *  to 127.0.0.1 to prevent client from using it to send to remote hosts,
-     *  because remote host then will receive 127.0.0.1 as the packet's 
-     *  source address.
-     */
-    pj_sockaddr_in	 remote_addr;
-
-    /** Struct to save incoming socket information. */
-    incoming_socket_rec	 accept_data;
-
-    /** When this transport should be closed. */
-    pj_time_val		 close_time;
-
-    /** List of callbacks to be called when client attempt to use this 
-     *  transport while it's not connected (i.e. still connecting). 
-     */
-    pj_list		 cb_list;
-};
-
+#include <pj/lock.h>
+
+
+#define THIS_FILE    "transport"
 
 /*
  * Transport manager.
  */
-struct pjsip_transport_mgr 
-{
-    pj_hash_table_t *transport_table;
-    pj_mutex_t	    *mutex;
+struct pjsip_tpmgr 
+{
+    pj_hash_table_t *table;
+    pj_lock_t	    *lock;
     pjsip_endpoint  *endpt;
     pj_ioqueue_t    *ioqueue;
-    pj_time_val	     next_idle_check;
-    pj_size_t        send_buf_size;
-    pj_size_t        recv_buf_size;
-    void           (*message_callback)(pjsip_endpoint*, pjsip_rx_data *rdata);
+    pj_timer_heap_t *timer_heap;
+    pjsip_tpfactory  factory_list;
+    void           (*msg_cb)(pjsip_endpoint*, pj_status_t, pjsip_rx_data*);
 };
 
-/*
- * Transport role.
- */
-typedef enum transport_role_e
-{
-    TRANSPORT_ROLE_LISTENER,
-    TRANSPORT_ROLE_TRANSPORT,
-} transport_role_e;
+
+
+/*****************************************************************************
+ *
+ * GENERAL TRANSPORT (NAMES, TYPES, ETC.)
+ *
+ *****************************************************************************/
+
+/*
+ * Transport names.
+ */
+const struct
+{
+    pjsip_transport_type_e type;
+    pj_uint16_t		   port;
+    pj_str_t		   name;
+    unsigned		   flag;
+} transport_names[] = 
+{
+    { PJSIP_TRANSPORT_UNSPECIFIED, 0, {NULL, 0}, 0},
+    { PJSIP_TRANSPORT_UDP, 5060, {"UDP", 3}, PJSIP_TRANSPORT_DATAGRAM},
+    { PJSIP_TRANSPORT_TCP, 5060, {"TCP", 3}, PJSIP_TRANSPORT_RELIABLE},
+    { PJSIP_TRANSPORT_TLS, 5061, {"TLS", 3}, PJSIP_TRANSPORT_RELIABLE | PJSIP_TRANSPORT_SECURE},
+    { PJSIP_TRANSPORT_SCTP, 5060, {"SCTP", 4}, PJSIP_TRANSPORT_RELIABLE}
+};
+
+
+/*
+ * Get transport type from name.
+ */
+PJ_DEF(pjsip_transport_type_e) 
+pjsip_transport_get_type_from_name(const pj_str_t *name)
+{
+    unsigned i;
+
+    for (i=0; i<PJ_ARRAY_SIZE(transport_names); ++i) {
+	if (pj_stricmp(name, &transport_names[i].name) == 0) {
+	    return transport_names[i].type;
+	}
+    }
+
+    pj_assert(!"Invalid transport name");
+    return PJSIP_TRANSPORT_UNSPECIFIED;
+}
+
+
+/*
+ * Get the transport type for the specified flags.
+ */
+PJ_DEF(pjsip_transport_type_e) 
+pjsip_transport_get_type_from_flag(unsigned flag)
+{
+    unsigned i;
+
+    for (i=0; i<PJ_ARRAY_SIZE(transport_names); ++i) {
+	if (transport_names[i].flag == flag) {
+	    return transport_names[i].type;
+	}
+    }
+
+    pj_assert(!"Invalid transport type");
+    return PJSIP_TRANSPORT_UNSPECIFIED;
+}
+
+PJ_DEF(unsigned)
+pjsip_transport_get_flag_from_type( pjsip_transport_type_e type )
+{
+    PJ_ASSERT_RETURN(type < PJ_ARRAY_SIZE(transport_names), 0);
+    return transport_names[type].flag;
+}
+
+/*
+ * Get the default SIP port number for the specified type.
+ */
+PJ_DEF(int) 
+pjsip_transport_get_default_port_for_type(pjsip_transport_type_e type)
+{
+    PJ_ASSERT_RETURN(type < PJ_ARRAY_SIZE(transport_names), 5060);
+    return transport_names[type].port;
+}
+
+
+/*****************************************************************************
+ *
+ * TRANSMIT DATA BUFFER MANIPULATION.
+ *
+ *****************************************************************************/
+
+/*
+ * Create new transmit buffer.
+ */
+PJ_DEF(pj_status_t) pjsip_tx_data_create( pjsip_tpmgr *mgr,
+					  pjsip_tx_data **p_tdata )
+{
+    pj_pool_t *pool;
+    pjsip_tx_data *tdata;
+    pj_status_t status;
+
+    PJ_ASSERT_RETURN(mgr && p_tdata, PJ_EINVAL);
+
+    PJ_LOG(5, ("", "pjsip_tx_data_create"));
+
+    pool = pjsip_endpt_create_pool( mgr->endpt, "tdta%p",
+				    PJSIP_POOL_LEN_TDATA,
+				    PJSIP_POOL_INC_TDATA );
+    if (!pool)
+	return PJ_ENOMEM;
+
+    tdata = pj_pool_zalloc(pool, sizeof(pjsip_tx_data));
+    tdata->pool = pool;
+    tdata->mgr = mgr;
+    pj_snprintf(tdata->obj_name, PJ_MAX_OBJ_NAME, "tdta%p", tdata);
+
+    status = pj_atomic_create(tdata->pool, 0, &tdata->ref_cnt);
+    if (status != PJ_SUCCESS) {
+	pjsip_endpt_destroy_pool( mgr->endpt, tdata->pool );
+	return status;
+    }
+    
+    //status = pj_lock_create_simple_mutex(pool, "tdta%p", &tdata->lock);
+    status = pj_lock_create_null_mutex(pool, "tdta%p", &tdata->lock);
+    if (status != PJ_SUCCESS) {
+	pjsip_endpt_destroy_pool( mgr->endpt, tdata->pool );
+	return status;
+    }
+
+    pj_ioqueue_op_key_init(&tdata->op_key, sizeof(tdata->op_key));
+
+    *p_tdata = tdata;
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Add reference to tx buffer.
+ */
+PJ_DEF(void) pjsip_tx_data_add_ref( pjsip_tx_data *tdata )
+{
+    pj_atomic_inc(tdata->ref_cnt);
+}
+
+/*
+ * Decrease transport data reference, destroy it when the reference count
+ * reaches zero.
+ */
+PJ_DEF(void) pjsip_tx_data_dec_ref( pjsip_tx_data *tdata )
+{
+    pj_assert( pj_atomic_get(tdata->ref_cnt) > 0);
+    if (pj_atomic_dec_and_get(tdata->ref_cnt) <= 0) {
+	PJ_LOG(5,(tdata->obj_name, "destroying txdata"));
+	pj_atomic_destroy( tdata->ref_cnt );
+	pj_lock_destroy( tdata->lock );
+	pjsip_endpt_destroy_pool( tdata->mgr->endpt, tdata->pool );
+    }
+}
+
+/*
+ * Invalidate the content of the print buffer to force the message to be
+ * re-printed when sent.
+ */
+PJ_DEF(void) pjsip_tx_data_invalidate_msg( pjsip_tx_data *tdata )
+{
+    tdata->buf.cur = tdata->buf.start;
+}
+
+PJ_DEF(pj_bool_t) pjsip_tx_data_is_valid( pjsip_tx_data *tdata )
+{
+    return tdata->buf.cur != tdata->buf.start;
+}
+
+
+
+/*****************************************************************************
+ *
+ * TRANSPORT KEY
+ *
+ *****************************************************************************/
 
 /*
  * Transport key for indexing in the hash table.
- * WATCH OUT FOR ALIGNMENT PROBLEM HERE!
  */
 typedef struct transport_key
@@ -162,555 +238,53 @@
 } transport_key;
 
-/*
- * Transport callback.
- */
-struct transport_callback
-{
-    PJ_DECL_LIST_MEMBER(struct transport_callback);
-
-    /** User defined token to be passed to the callback. */
-    void *token;
-
-    /** The callback function. */
-    void (*cb)(pjsip_transport_t *tr, void *token, pj_status_t status);
-
-};
-
-/*
- * Transport names.
- */
-const struct
-{
-    pjsip_transport_type_e type;
-    pj_uint16_t		   port;
-    pj_str_t		   name;
-} transport_names[] = 
-{
-    { PJSIP_TRANSPORT_UNSPECIFIED, 0, {NULL, 0}},
-    { PJSIP_TRANSPORT_UDP, 5060, {"UDP", 3}},
-#if PJ_HAS_TCP
-    { PJSIP_TRANSPORT_TCP, 5060, {"TCP", 3}},
-    { PJSIP_TRANSPORT_TLS, 5061, {"TLS", 3}},
-    { PJSIP_TRANSPORT_SCTP, 5060, {"SCTP", 4}}
-#endif
-};
-
-static void on_ioqueue_read(pj_ioqueue_key_t *key, 
-                            pj_ioqueue_op_key_t *op_key, 
-                            pj_ssize_t bytes_read);
-static void on_ioqueue_write(pj_ioqueue_key_t *key, 
-                             pj_ioqueue_op_key_t *op_key, 
-                             pj_ssize_t bytes_sent);
-static void on_ioqueue_accept(pj_ioqueue_key_t *key, 
-                              pj_ioqueue_op_key_t *op_key, 
-			      pj_sock_t newsock,
-                              int status);
-static void on_ioqueue_connect(pj_ioqueue_key_t *key, 
-                               int status);
-
-static pj_ioqueue_callback ioqueue_transport_callback = 
-{
-    &on_ioqueue_read,
-    &on_ioqueue_write,
-    &on_ioqueue_accept,
-    &on_ioqueue_connect
-};
-
-static void init_key_from_transport(transport_key *key, 
-				    const pjsip_transport_t *tr)
-{
-    /* This is to detect alignment problems. */
-    pj_assert(sizeof(transport_key) == 8);
-
-    key->type = (pj_uint8_t)tr->type;
-    key->zero = 0;
-    key->addr = pj_sockaddr_in_get_addr(&tr->remote_addr).s_addr;
-    key->port = pj_sockaddr_in_get_port(&tr->remote_addr);
-    /*
-    if (key->port == 0) {
-	key->port = pj_sockaddr_in_get_port(&tr->local_addr);
-    }
-    */
-}
-
-#if PJ_HAS_TCP
-static void init_tcp_key(transport_key *key, pjsip_transport_type_e type,
-			 const pj_sockaddr_in *addr)
-{
-    /* This is to detect alignment problems. */
-    pj_assert(sizeof(transport_key) == 8);
-
-    key->type = (pj_uint8_t)type;
-    key->zero = 0;
-    key->addr = pj_sockaddr_in_get_addr(addr).s_addr;
-    key->port = pj_sockaddr_in_get_port(addr);
-}
-#endif
-
-static void init_udp_key(transport_key *key, pjsip_transport_type_e type,
-			  const pj_sockaddr_in *addr)
-{
-    PJ_UNUSED_ARG(addr);
-
-    /* This is to detect alignment problems. */
-    pj_assert(sizeof(transport_key) == 8);
-
-    pj_memset(key, 0, sizeof(*key));
-    key->type = (pj_uint8_t)type;
-
-#if 0	/* Not sure why we need to make 127.0.0.1 a special case */
-    if (addr->sin_addr.s_addr == inet_addr("127.0.0.1")) {
-	/* This looks more complicated than it is because key->addr uses
-	 * the host version of the address (i.e. converted with ntohl()).
-	 */
-	pj_str_t localaddr = pj_str("127.0.0.1");
-	pj_sockaddr_in addr;
-	pj_sockaddr_set_str_addr(&addr, &localaddr);
-	key->addr = pj_sockaddr_in_get_addr(&addr);
-    }
-#endif
-}
-
-/*
- * Get type format name (for pool name).
- */
-static const char *transport_get_name_format( int type )
-{
-    switch (type) {
-    case PJSIP_TRANSPORT_UDP:
-	return " udp%p";
-#if PJ_HAS_TCP
-    case PJSIP_TRANSPORT_TCP:
-	return " tcp%p";
-    case PJSIP_TRANSPORT_TLS:
-	return " tls%p";
-    case PJSIP_TRANSPORT_SCTP:
-	return "sctp%p";
-#endif
-    }
-    pj_assert(0);
-    return 0;
-}
-
-/*
- * Get the default SIP port number for the specified type.
- */
-PJ_DEF(int) pjsip_transport_get_default_port_for_type(pjsip_transport_type_e type)
-{
-    return transport_names[type].port;
-}
-
-/*
- * Get transport name.
- */
-static const char *get_type_name(int type)
-{
-    return transport_names[type].name.ptr;
-}
-
-/*
- * Get transport type from name.
- */
-PJ_DEF(pjsip_transport_type_e) 
-pjsip_transport_get_type_from_name(const pj_str_t *name)
-{
-    unsigned i;
-
-    for (i=0; i<PJ_ARRAY_SIZE(transport_names); ++i) {
-	if (pj_stricmp(name, &transport_names[i].name) == 0) {
-	    return transport_names[i].type;
-	}
-    }
-    return PJSIP_TRANSPORT_UNSPECIFIED;
-}
-
-/*
- * Create new transmit buffer.
- */
-pj_status_t pjsip_tx_data_create( pjsip_transport_mgr *mgr,
-                                  pjsip_tx_data **p_tdata )
-{
-    pj_pool_t *pool;
-    pjsip_tx_data *tdata;
+
+/*****************************************************************************
+ *
+ * TRANSPORT
+ *
+ *****************************************************************************/
+
+static void transport_send_callback(pjsip_transport *transport,
+				    void *token,
+				    pj_status_t status)
+{
+    pjsip_tx_data *tdata = token;
+
+    PJ_UNUSED_ARG(transport);
+
+    /* Mark pending off so that app can resend/reuse txdata from inside
+     * the callback.
+     */
+    tdata->is_pending = 0;
+
+    /* Call callback, if any. */
+    if (tdata->cb) {
+	(*tdata->cb)(tdata->token, tdata, status);
+    }
+
+    /* Decrement reference count. */
+    pjsip_tx_data_dec_ref(tdata);
+}
+
+/*
+ * Send a SIP message using the specified transport.
+ */
+PJ_DEF(pj_status_t) pjsip_transport_send(  pjsip_transport *tr, 
+					   pjsip_tx_data *tdata,
+					   const pj_sockaddr_in *addr,
+					   void *token,
+					   void (*cb)(void *token, 
+						      pjsip_tx_data *tdata,
+						      pj_status_t))
+{
     pj_status_t status;
 
-    PJ_LOG(5, ("", "pjsip_tx_data_create"));
-
-    PJ_ASSERT_RETURN(mgr && p_tdata, PJ_EINVAL);
-
-    pool = pjsip_endpt_create_pool( mgr->endpt, "ptdt%p",
-				    PJSIP_POOL_LEN_TDATA,
-				    PJSIP_POOL_INC_TDATA );
-    if (!pool) {
-	return PJ_ENOMEM;
-    }
-    tdata = pj_pool_calloc(pool, 1, sizeof(pjsip_tx_data));
-    tdata->pool = pool;
-    tdata->mgr = mgr;
-    pj_sprintf(tdata->obj_name,"txd%p", tdata);
-
-    status = pj_atomic_create(tdata->pool, 0, &tdata->ref_cnt);
-    if (status != PJ_SUCCESS) {
-	pjsip_endpt_destroy_pool( mgr->endpt, tdata->pool );
-	return status;
-    }
-    
-    *p_tdata = tdata;
-    return PJ_SUCCESS;
-}
-
-/*
- * Add reference to tx buffer.
- */
-PJ_DEF(void) pjsip_tx_data_add_ref( pjsip_tx_data *tdata )
-{
-    pj_atomic_inc(tdata->ref_cnt);
-}
-
-/*
- * Decrease transport data reference, destroy it when the reference count
- * reaches zero.
- */
-PJ_DEF(void) pjsip_tx_data_dec_ref( pjsip_tx_data *tdata )
-{
-    pj_assert( pj_atomic_get(tdata->ref_cnt) > 0);
-    if (pj_atomic_dec_and_get(tdata->ref_cnt) <= 0) {
-	PJ_LOG(6,(tdata->obj_name, "destroying txdata"));
-	pj_atomic_destroy( tdata->ref_cnt );
-	pjsip_endpt_destroy_pool( tdata->mgr->endpt, tdata->pool );
-    }
-}
-
-/*
- * Invalidate the content of the print buffer to force the message to be
- * re-printed when sent.
- */
-PJ_DEF(void) pjsip_tx_data_invalidate_msg( pjsip_tx_data *tdata )
-{
-    tdata->buf.cur = tdata->buf.start;
-}
-
-/*
- * Get the transport type.
- */
-PJ_DEF(pjsip_transport_type_e) pjsip_transport_get_type( const pjsip_transport_t * tr)
-{
-    return tr->type;
-}
-
-/*
- * Get transport type from transport flag.
- */
-PJ_DEF(pjsip_transport_type_e) pjsip_get_transport_type_from_flag(unsigned flag)
-{
-#if PJ_HAS_TCP
-    if (flag & PJSIP_TRANSPORT_SECURE) {
-	return PJSIP_TRANSPORT_TLS;
-    } else if (flag & PJSIP_TRANSPORT_RELIABLE) {
-	return PJSIP_TRANSPORT_TCP;
-    } else 
-#else
-    PJ_UNUSED_ARG(flag);
-#endif
-    {
-	return PJSIP_TRANSPORT_UDP;
-    }
-}
-
-/*
- * Get the transport type name.
- */
-PJ_DEF(const char *) pjsip_transport_get_type_name( const pjsip_transport_t * tr)
-{
-    return get_type_name(tr->type);
-}
-
-/*
- * Get the transport's object name.
- */
-PJ_DEF(const char*) pjsip_transport_get_obj_name( const pjsip_transport_t *tr )
-{
-    return tr->obj_name;
-}
-
-/*
- * Get the transport's reference counter.
- */
-PJ_DEF(int) pjsip_transport_get_ref_cnt( const pjsip_transport_t *tr )
-{
-    return pj_atomic_get(tr->ref_cnt);
-}
-
-/*
- * Get transport local address.
- */
-PJ_DEF(const pj_sockaddr_in*) pjsip_transport_get_local_addr( pjsip_transport_t *tr )
-{
-    return &tr->local_addr;
-}
-
-/*
- * Get address name.
- */
-PJ_DEF(const pj_sockaddr_in*) pjsip_transport_get_addr_name (pjsip_transport_t *tr)
-{
-    return &tr->addr_name;
-}
-
-/*
- * Get transport remote address.
- */
-PJ_DEF(const pj_sockaddr_in*) pjsip_transport_get_remote_addr( const pjsip_transport_t *tr )
-{
-    return &tr->remote_addr;
-}
-
-/*
- * Get transport flag.
- */
-PJ_DEF(unsigned) pjsip_transport_get_flag( const pjsip_transport_t * tr )
-{
-    return tr->flag;
-}
-
-/*
- * Add reference to the specified transport.
- */
-PJ_DEF(void) pjsip_transport_add_ref( pjsip_transport_t * tr )
-{
-    pj_atomic_inc(tr->ref_cnt);
-}
-
-/*
- * Decrease the reference time of the transport.
- */
-PJ_DEF(void) pjsip_transport_dec_ref( pjsip_transport_t *tr )
-{
-    pj_assert(tr->ref_cnt > 0);
-    if (pj_atomic_dec_and_get(tr->ref_cnt) == 0) {
-	pj_gettimeofday(&tr->close_time);
-	tr->close_time.sec += PJSIP_TRANSPORT_CLOSE_TIMEOUT;
-    }
-}
-
-/*
- * Open the underlying transport.
- */
-static pj_status_t create_socket( pjsip_transport_type_e type,
-				  pj_sockaddr_in *local,
-                                  pj_sock_t *p_sock)
-{
-    int sock_family;
-    int sock_type;
-    int sock_proto;
-    int len;
-    pj_status_t status;
-    pj_sock_t sock;
-
-    /* Set socket parameters */
-    if (type == PJSIP_TRANSPORT_UDP) {
-	sock_family = PJ_AF_INET;
-	sock_type = PJ_SOCK_DGRAM;
-	sock_proto = 0;
-
-#if PJ_HAS_TCP
-    } else if (type == PJSIP_TRANSPORT_TCP) {
-	sock_family = PJ_AF_INET;
-	sock_type = PJ_SOCK_STREAM;
-	sock_proto = 0;
-#endif
-    } else {
-	return PJ_EINVAL;
-    }
-
-    /* Create socket. */
-    status = pj_sock_socket( sock_family, sock_type, sock_proto, &sock);
-    if (status != PJ_SUCCESS)
-	return status;
-
-    /* Bind the socket to the requested address, or if no address is
-     * specified, let the operating system chooses the address.
-     */
-    if (/*local->sin_addr.s_addr != 0 &&*/ local->sin_port != 0) {
-	/* Bind to the requested address. */
-        status = pj_sock_bind(sock, local, sizeof(*local));
-	if (status != PJ_SUCCESS) {
-	    pj_sock_close(sock);
-	    return status;
-	}
-    } else if (type == PJSIP_TRANSPORT_UDP) {
-	/* Only for UDP sockets: bind to any address so that the operating 
-	 * system allocates the port for us. For TCP, let the OS implicitly
-	 * bind the socket with connect() syscall (if we bind now, then we'll
-	 * get 0.0.0.0 as local address).
-	 */
-	pj_memset(local, 0, sizeof(*local));
-	local->sin_family = PJ_AF_INET;
-        status = pj_sock_bind(sock, local, sizeof(*local));
-	if (status != PJ_SUCCESS) {
-	    pj_sock_close(sock);
-	    return status;
-	}
-
-	/* Get the local address. */
-	len = sizeof(pj_sockaddr_in);
-        status = pj_sock_getsockname(sock, local, &len);
-	if (status != PJ_SUCCESS) {
-	    pj_sock_close(sock);
-	    return status;
-	}
-    }
-
-    *p_sock = sock;
-    return PJ_SUCCESS;
-}
-
-/*
- * Close the transport.
- */
-static void destroy_socket( pjsip_transport_t * tr)
-{
-    pj_assert( pj_atomic_get(tr->ref_cnt) == 0);
-    pj_sock_close(tr->sock);
-    tr->sock = -1;
-}
-
-/*
- * Create a new transport object.
- */
-static pj_status_t create_transport( pjsip_transport_mgr *mgr,
-				     pjsip_transport_type_e type,
-				     pj_sock_t sock_hnd,
-				     const pj_sockaddr_in *local_addr,
-				     const pj_sockaddr_in *addr_name,
-				     pjsip_transport_t **p_transport )
-{
-    pj_pool_t *tr_pool=NULL, *rdata_pool=NULL;
-    pjsip_transport_t *tr = NULL;
-    pj_status_t status;
-
-    /* Allocate pool for transport from endpoint. */
-    tr_pool = pjsip_endpt_create_pool( mgr->endpt,
-				       transport_get_name_format(type),
-				       PJSIP_POOL_LEN_TRANSPORT,
-				       PJSIP_POOL_INC_TRANSPORT );
-    if (!tr_pool) {
-	status = PJ_ENOMEM;
-	goto on_error;
-    }
-
-    /* Allocate pool for rdata from endpoint. */
-    rdata_pool = pjsip_endpt_create_pool( mgr->endpt,
-					     "prdt%p",
-					     PJSIP_POOL_LEN_RDATA,
-					     PJSIP_POOL_INC_RDATA );
-    if (!rdata_pool) {
-	status = PJ_ENOMEM;
-	goto on_error;
-    }
-
-    /* Allocate and initialize the transport. */
-    tr = pj_pool_calloc(tr_pool, 1, sizeof(*tr));
-    tr->pool = tr_pool;
-    tr->type = type;
-    tr->mgr = mgr;
-    tr->sock = sock_hnd;
-    pj_memcpy(&tr->local_addr, local_addr, sizeof(pj_sockaddr_in));
-    pj_list_init(&tr->cb_list);
-    pj_sprintf(tr->obj_name, transport_get_name_format(type), tr);
-
-    if (type != PJSIP_TRANSPORT_UDP) {
-	tr->flag |= PJSIP_TRANSPORT_RELIABLE;
-    }
-
-    /* Address name. */
-    if (addr_name == NULL) {
-	addr_name = &tr->local_addr;
-    } 
-    pj_memcpy(&tr->addr_name, addr_name, sizeof(*addr_name));
-
-    /* Create atomic */
-    status = pj_atomic_create(tr_pool, 0, &tr->ref_cnt);
-    if (status != PJ_SUCCESS)
-	goto on_error;
-    
-    /* Init rdata in the transport. */
-    tr->rdata = pj_pool_alloc(rdata_pool, sizeof(*tr->rdata));
-    tr->rdata->pool = rdata_pool;
-    tr->rdata->len = 0;
-    tr->rdata->transport = tr;
-    
-    /* Init transport mutex. */
-    status = pj_mutex_create_recursive(tr_pool, "mtr%p", &tr->tr_mutex);
-    if (status != PJ_SUCCESS)
-	goto on_error;
-
-    /* Register to I/O Queue */
-    status = pj_ioqueue_register_sock( tr_pool, mgr->ioqueue, 
-				       tr->sock, tr,
-				       &ioqueue_transport_callback,
-				       &tr->key);
-    if (status != PJ_SUCCESS)
-	goto on_error;
-
-    *p_transport = tr;
-    return PJ_SUCCESS;
-
-on_error:
-    if (tr && tr->tr_mutex) {
-	pj_mutex_destroy(tr->tr_mutex);
-    }
-    if (tr_pool) {
-	pjsip_endpt_destroy_pool(mgr->endpt, tr_pool);
-    }
-    if (rdata_pool) {
-	pjsip_endpt_destroy_pool(mgr->endpt, rdata_pool);
-    }
-    return status;
-}
-
-/*
- * Destroy transport.
- */
-static void destroy_transport( pjsip_transport_mgr *mgr, pjsip_transport_t *tr)
-{
-    transport_key hash_key;
-
-    /* Remove from I/O queue. */
-    pj_ioqueue_unregister( tr->key );
-
-    /* Remove from hash table */
-    init_key_from_transport(&hash_key, tr);
-    pj_hash_set(NULL, mgr->transport_table, &hash_key, sizeof(hash_key), NULL);
-
-    /* Close transport. */
-    destroy_socket(tr);
-
-    /* Destroy the transport mutex. */
-    pj_mutex_destroy(tr->tr_mutex);
-
-    /* Destroy atomic */
-    pj_atomic_destroy( tr->ref_cnt );
-
-    /* Release the pool associated with the rdata. */
-    pjsip_endpt_destroy_pool(mgr->endpt, tr->rdata->pool );
-
-    /* Release the pool associated with the transport. */
-    pjsip_endpt_destroy_pool(mgr->endpt, tr->pool );
-}
-
-
-static pj_status_t transport_send_msg( pjsip_transport_t *tr, 
-				       pjsip_tx_data *tdata,
-				       const pj_sockaddr_in *addr, 
-				       pj_ssize_t *p_sent)
-{
-    const char *buf = tdata->buf.start;
-    pj_ssize_t size;
-    pj_status_t status;
-
-    /* Can only send if tdata is not being sent! */
-    if (pj_ioqueue_is_pending(tr->key, &tdata->op_key))
+    PJ_ASSERT_RETURN(tr && tdata && addr, PJ_EINVAL);
+
+    /* Is it currently being sent? */
+    if (tdata->is_pending) {
+	pj_assert(!"Invalid operation step!");
 	return PJSIP_EPENDINGTX;
+    }
 
     /* Allocate buffer if necessary. */
@@ -721,6 +295,8 @@
     }
 
-    /* Print the message if it's not printed */
-    if (tdata->buf.cur <= tdata->buf.start) {
+    /* Do we need to reprint? */
+    if (!pjsip_tx_data_is_valid(tdata)) {
+	pj_ssize_t size;
+
 	size = pjsip_msg_print( tdata->msg, tdata->buf.start, 
 			        tdata->buf.end - tdata->buf.start);
